﻿using MotorBoat.MovementStrategy;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MotorBoat.DrawningObjects;

namespace MotorBoat.MovementStrategy
{
    /// <summary>
    /// Реализация интерфейса IDrawningObject для работы с объектом DrawningBoat (паттерн Adapter)
    /// </summary>
    public class DrawningObjectBoat : IMoveableObject
    {
        private readonly DrawningBoat? _drawningBoat = null;
        public DrawningObjectBoat(DrawningBoat drawningBoat)
        {
            _drawningBoat = drawningBoat;
        }
        public ObjectParameters? GetObjectPosition
        {
            get
            {
                if (_drawningBoat == null || _drawningBoat.EntityBoat == null)
                {
                    return null;
                }
                return new ObjectParameters(_drawningBoat.GetPosX,
                _drawningBoat.GetPosY, _drawningBoat.GetWidth, _drawningBoat.GetHeight);
            }
        }
        public int GetStep => (int)(_drawningBoat?.EntityBoat?.Step ?? 0);
        public bool CheckCanMove(DirectionType direction) =>
        _drawningBoat?.CanMove(direction) ?? false;
        public void MoveObject(DirectionType direction) =>
        _drawningBoat?.MoveTransport(direction);
    }
}