﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MotorBoat.Entities;

namespace MotorBoat.Entities
{
    /// <summary>
    /// Класс-сущность моторная лодка
    /// </summary>
    public class EntityMotorBoat : EntityBoat
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color AdditionalColor { get; private set; }

        /// <summary>
        /// Признак (опция) наличия двигателя в корме
        /// </summary>
        public bool Engine { get; private set; }

        /// <summary>
        /// Признак (опция) наличия защитного стекла спереди
        /// </summary>
        public bool Glass { get; private set; }

        /// <summary>
        /// Инициализация полей объекта-класса моторной лодки
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес катера</param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="engine">Признак наличия двигателя в корме</param>
        /// <param name="glass">Признак наличия защитного стекла впереди</param>

        public EntityMotorBoat(int speed, double weight, Color bodyColor, Color additionalColor, bool engine, bool glass) :
            base (speed, weight, bodyColor)
        {
            AdditionalColor = additionalColor;
            Engine = engine;
            Glass = glass;
        }

        internal void setAdditionalColor(Color color)
        {
            AdditionalColor = color;
        }
    }
}